#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <STDLIB.H>
#include <conio.h>
#include <iostream.h>

#define MAXN 20

int n;
int matr [MAXN][MAXN];
int niz [MAXN] = {0,};
int father [MAXN] = {0,};
int number = 0;
int col = 2;

char ask[30];

void printgraf()
  {
  int i,j;
  char buf[10];
  double ud = M_PI*2/n;
  int R=200,x=getmaxx()/2,y=getmaxy()/2;

  for(i = 0; i < n; i++)
    {
    setcolor(1);
    setfillstyle(1,1);
    pieslice(x+R*cos(ud*i),y+R*sin(ud*i),0,360,5);
	setcolor(14);
    outtextxy(x+(R+10)*cos(ud*i), y+(R+10)*sin(ud*i),
	      itoa(matr[i][i],buf,10));
    for(j = i+1;j < n; j++)
      {
      if(matr[i][j] != 0)
	{
	setcolor(16-matr[i][j]);
	line(x+R*cos(ud*i), y+R*sin(ud*i),
	     x+R*cos(ud*j), y+R*sin(ud*j));
	}
      }
    }
  }

int min(int value1, int value2)
  {
  return ( (value1 > value2) ? value1 : value2);
  }

void basic(int v)
  {
  number++;
  matr[v][v] = number;
  niz[v] = matr[v][v];
  for (int i = v; i < n; i++)
	if ((matr[v][i] != 0) && (matr[i][i] == 0))
      {
      matr[v][i] = col;
      matr[i][v] = col;
      father[i] = v;
      basic(i);
      if (niz[i] >= matr[v][v])
	{
	niz[v] = min(niz[v],niz[i]);
	col++;
	}
      }
    else
	  if (i != father[v])
	niz[v] = min(niz[v],matr[i][i]);
  }

void main()
  {
  int driver,mode,i,j,k;
   //vvod grapha
  cout << "Enter amount of members: ";
  cin >> n;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++) matr[i][j] = -1;

  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
      {
      if ((matr[j][i] == 1) || (i == j))
	{
	matr[i][j] = 1;
	if (i == j)
	  {
	  matr[i][j] = 0;
	  }
	}
      else
	{
	if (matr[j][i] == 0)
	  {
	  matr[i][j] = 0;
	  }
	else
	  {
	  sprintf(ask,"%d and %d conected ? (y/n): ",i+1,j+1);
	  cout << ask;
	  if (getch() == 'y')
		{
		matr[i][j] = 1;
		cout << "Yes \n";
		}
	  else
		{
		matr[i][j] = 0;
		cout << "No \n";
		}
	  }
	}
	  }
	  //konec vvoda

  driver = VGA;
  mode = VGAHI;
  initgraph(&driver,&mode,"d:\\bc\\bgi");
  if (graphresult() != 0) {printf("Graphic error..."); exit(1); }

  basic(0);
  for (i = 0; i < n; i++)
	for (j = 0; j < n; j++)
	  for (k = 0; k < n; k++)
	if ((matr[j][i] == matr[i][k])
		&& (matr[j][i] != 0)
		&& (matr[j][k] != 0)
		&& (j != k))
	  matr[j][k] = matr[j][i];
  printgraf();
  getch();

  closegraph();
  }
