/*********************************************\
* 5th laborators work at C++                  *
* Graphs                                      *
\*********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <conio.h>

#define MAXN 20

struct list
  {
  int p1,p2,l;
  list *prev;
  };

list *top,*work1,*work2;
int i,j,k,l,cs,p1,p2;
char ask[30];
int n;
int matr [MAXN][MAXN];//matrica
int m [MAXN][MAXN];//rastoyaniya

void put(int p1, int p2, int l)
  {
  work1 = (list *)malloc(sizeof(list));
  work1->p1 = p1;
  work1->p2 = p2;
  work1->l = l;
  work1->prev = top;
  top = work1;
  }

void get(int *p1,int *p2, int *l)
  {
  *p1 = top->p1;
  *p2 = top->p2;
  *l = top->l;
  work1 = top;
  top = top->prev;
  free(work1);
  }

void print_matr()
  {
  cout << "\n\n\nGRAPH\n";
  cout << "------------\n\n  | ";
  for (i = 0; i < n; i++) cout << i << ' ';
  cout << '\n';
  cout << "--+----------\n";
  for (i = 0; i < n; i++)
    {
	cout << i << " | ";
	for (j = 0; j < n; j++)
      cout << matr[i][j] << ' ';
    cout << '\n';
    }
  }

void print_m()
  {
  cout << "\n\n\nWAYS\n";
  cout << "------------\n\n  | ";
  for (i = 0; i < n; i++) cout << i << ' ';
  cout << '\n';
  cout << "--+----------\n";
  for (i = 0; i < n; i++)
	{
	cout << i << " | ";
	for (j = 0; j < n; j++)
	  cout << m[i][j] << ' ';
	cout << '\n';
	}
  }

void main()
  {
  cs = 0;
  cout << "Enter amount of members: ";
  cin >> n;
  //soedineniya zapolnyaem -1
  for (i = 0; i < n; i++)
	for (j = 0; j < n; j++) matr[i][j] = -1;
  //rasstoyaniya mejdu vershinami zapolnyaem 0
  for (i = 0; i < n; i++)
	for (j = 0; j < n; j++) m[i][j] = 0;

//vvod grapha
  for (i = 0; i < n; i++)
	for (j = 0; j < n; j++)
	  {
	  if ((matr[j][i] == 1) || (i == j)) //proverka ne soedineni li eshe vershini lido sama s soboy
		{
		matr[i][j] = 1;
		m[i][j] = m[j][i];
		if (i == j) //esli iz vershini v samu sebya
		  {
		  m[i][j] = 0;
		  matr[i][j] = 0;
		  }
		else cs++;//colichestvo soedineniy +1
		}
	  else//esli iz vershini v vershinu eshe ne soedenennuyu s ney
		{
		if (matr[j][i] == 0)//esli uje ne bili soedineni
		  {
		  matr[i][j] = 0;
		  m[i][j] = 0;
		  }
		else
		  {
		  sprintf(ask,"%d and %d conected ? (y/n): ",i+1,j+1);
		  cout << ask;
		  if (getch() == 'y')
			{
			matr[i][j] = 1;
			cout << "Yes \nEnter long of way: ";
			cin >> m[i][j];
			cs++;
			}
		  else
			{
			matr[i][j] = 0;
			cout << "No \n";
			m[i][j] = 0;
			}
		  }
		}
	  }
//konec vvoda grapha

//raspechativaem matricu i puti
  print_matr();
  print_m();

  //sozdaem spisok
  top = (list *)malloc(sizeof(list));
  work2 = top;

  //zapisivaem puti v ochered po ubivaniyu dlinn zoed. vershini
  for (i = 1; i <= cs/2; i++)
	{
	l = 0;
	for (j = 0; j < n; j++)
	  for(k = 0; k < n; k++)
		if ((m[j][k] > l) && (m[j][k] != 0))
		  {
		  l = m[j][k];
		  p1 = j;
		  p2 = k;
		  }
	put(p1,p2,l);
	m[p1][p2] = 0;
	m[p2][p1] = 0;
	}

  while (top != work2)
	{
	get(&i,&j,&l);

	if ((!matr[i][i] || !matr[j][j])
		 && !(matr[i][i] && matr[j][j]))
	  cout << i << " & " << j << " \n";

	matr[i][i] = 1;
	matr[j][j] = 1;
	}

  cout << "\n\n-------------\n";
  }
